#include "CUDA_Lightcuts.h"
//vermutlich kein memory leak

float4* CUDA_LightCuts::colorTexture = new float4[1];//delete ok
float4* CUDA_LightCuts::cutSizeTexture = new float4[1];//delete ok

float4* CUDA_LightCuts::positionOfVPL = 0;//delete ok
float4* CUDA_LightCuts::normalOfVPL_IntensityRatio = 0;//delete ok //intensity ratio wird in normalOfVPL_IntensityRatio.w gespeichert!!!
float4* CUDA_LightCuts::colorOfVPL = 0;//delete ok
int4* CUDA_LightCuts::shadowMapAndLightSpaceOfVPL = 0;//delete ok

//Cluster structure, aligned memory to enable coalesced access:
int4* CUDA_LightCuts::indices = 0;//delete ok //indices.r = leftChild, indices.g = rightChild, indices.b = index of representative Light (in datastructure above!)
float4* CUDA_LightCuts::bounds_A = 0;//delete ok
float4* CUDA_LightCuts::bounds_B = 0;//delete ok
float4* CUDA_LightCuts::color_lch = 0;
float4* CUDA_LightCuts::estRad_RadUpperBound_errorBound = 0;//delete ok

float4* CUDA_LightCuts::positionsInWorld = 0;//delete ok
float4* CUDA_LightCuts::normalsInWorld = 0;//delete ok
float4* CUDA_LightCuts::colorsInWorld = 0;//delete ok

float* CUDA_LightCuts::lightMatricesCUDA = 0;//delete ok


unsigned int CUDA_LightCuts::colorTextureGL;
unsigned int CUDA_LightCuts::cutSizeTextureGL;

void CUDA_LightCuts::cudaTest(void)
{
	//ClusterInCUDA* cpuPointer = new ClusterInCUDA[10];
	//VPL_InCUDA a;
	//a.colorB = 0.0f;
	//a.colorG = 0.0f;
	//a.colorR = 0.0f;
	//a.colorW = 0.0f;
	//a.intensityRatio = 0.0f;
	//a.lightSpaceMatrixAtPixelX = 0;
	//a.lightSpaceMatrixAtPixelY = 0;
	//a.normalX = 0.0f;
	//a.normalY = 0.0f;
	//a.normalZ = 0.0f;
	//a.positionX = 0.0f;
	//a.positionY = 0.0f;
	//a.positionZ = 0.0f;
	//a.shadowMapAtPixelX = 0;
	//a.shadowMapAtPixelY = 0;

	//float4 test = make_float4(1.0f, 1.0f, 1.0f, 1.0f);

	//for (int i = 0; i < 10; i++)
	//{
	//	cpuPointer[i].bounds_A = test;
	//	cpuPointer[i].bounds_B = test;

	//	cpuPointer[i].errorBound = i;
	//	cpuPointer[i].estimatedRadiance = i;
	//	cpuPointer[i].geometryTerm = i;
	//	cpuPointer[i].intensity = i;
	//	cpuPointer[i].leftChild = i;
	//	cpuPointer[i].materialTerm = i;
	//	cpuPointer[i].radianceUpperBound = i;
	//	cpuPointer[i].radianceUpperBound = i;
	//	cpuPointer[i].rightChild = i;
	//	cpuPointer[i].visibilityTerm = i;
	//}
	//printf("Before GPU:\n");
	//for (int i = 0; i < 10; i++)
	//{
	//	printf("CudaTest%i: %i\n", i, cpuPointer[i].leftChild);
	//}

	//ClusterInCUDA* gpuPointer;

	//cudaMalloc((void **)&gpuPointer, sizeof(ClusterInCUDA) * 10);
	//cudaMemcpy(gpuPointer, cpuPointer, sizeof(ClusterInCUDA) * 10, cudaMemcpyHostToDevice);

	//cudaTest_launchKernel(gpuPointer);

	//cudaMemcpy(cpuPointer, gpuPointer, sizeof(ClusterInCUDA) * 10, cudaMemcpyDeviceToHost);

	//cudaFree(gpuPointer);

	//printf("After GPU:\n");
	//for (int i = 0; i < 10; i++)
	//{
	//	printf("CudaTest%i: %i\n", i, cpuPointer[i].leftChild);
	//}

	//delete[] cpuPointer;
}
void CUDA_LightCuts::renderImageWithRadiosityCUDA()
{
	int anzPixels = renderingHeight * renderingWidth;
	
	if (colorTexture!=0)
	{
		delete[] colorTexture;
		colorTexture = 0;
	}

	float* ism_buffer = new float[ism_atlas_size * ism_atlas_size];
	for (int i = 0; i < ism_atlas_size * ism_atlas_size; i++)
	{
		ism_buffer[i] = shadowMap[i*4];
	}

	colorTexture = new float4[anzPixels];

	int numberOfClusters = (TextureManager::anzLights*2) - 1;

	int numberOfBytes = 0;

	
//	float4* positionsInWorldGPU = 0;	numberOfBytes += sizeof(float4) * anzPixels; //takes now place in allocateTextureMemory!
//	float4* normalsInWorldGPU = 0;		numberOfBytes += sizeof(float4) * anzPixels; //takes now place in allocateTextureMemory!
										numberOfBytes += sizeof(float4) * anzPixels;
										numberOfBytes += sizeof(float4) * anzPixels;

	float4* colorsInWorldGPU = 0;		numberOfBytes += sizeof(float4) * anzPixels;
	float4* colorTextureGPU = 0;		numberOfBytes += sizeof(float4) * anzPixels;

										numberOfBytes += 7 * sizeof(float4) * numberOfClusters;//see large comment directly below
										numberOfBytes += 2 * sizeof(int4) * numberOfClusters;  //see large comment directly below
										numberOfBytes += sizeof(float) * lightSpaceMatrices_size * lightSpaceMatrices_size * 4; //lightSpace matrices
										numberOfBytes += sizeof(float) * ism_atlas_size * ism_atlas_size; //shadow map

	printf("GPU: Allocating a total of %i KB", numberOfBytes >> 10);

	if (numberOfBytes > int(CUDA_PushPull::maxGlobalMemoryInBytes))
	{
		printf("\nERROR! Trying to allocate %i KB, but your device provides only %iKB. Cancelling rendering process.\n",   numberOfBytes >> 10,  CUDA_PushPull::maxGlobalMemoryInBytes >> 10);
		return;
	}

	VPL_InCUDA vplPointersGPU;
	ClusterInCUDA clusterPointersGPU;

	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.positionOfVPL, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.colorOfVPL, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.normalOfVPL_IntensityRatio, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.shadowMapAndLightSpaceOfVPL, sizeof(int4) * numberOfClusters));

	cutilSafeCall(cudaMemcpy(vplPointersGPU.positionOfVPL, positionOfVPL, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(vplPointersGPU.colorOfVPL, colorOfVPL, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(vplPointersGPU.normalOfVPL_IntensityRatio, normalOfVPL_IntensityRatio, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(vplPointersGPU.shadowMapAndLightSpaceOfVPL, shadowMapAndLightSpaceOfVPL, sizeof(int4) * numberOfClusters, cudaMemcpyHostToDevice));

	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.bounds_A, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.bounds_B, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.estRad_RadUpperBound_errorBound, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.color_lch, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.indices, sizeof(int4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.lightSpaceMatrices, sizeof(float) * lightSpaceMatrices_size * lightSpaceMatrices_size * 4));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.shadowMaps, sizeof(float) * ism_atlas_size * ism_atlas_size));

	cutilSafeCall(cudaMemcpy(clusterPointersGPU.bounds_A, bounds_A, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.bounds_B, bounds_B, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.estRad_RadUpperBound_errorBound, estRad_RadUpperBound_errorBound, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.color_lch, color_lch, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.indices, indices, sizeof(int4) * numberOfClusters, cudaMemcpyHostToDevice));	
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.lightSpaceMatrices, lightMatricesCUDA, sizeof(float) * lightSpaceMatrices_size * lightSpaceMatrices_size * 4, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.shadowMaps, ism_buffer, sizeof(float) * ism_atlas_size * ism_atlas_size, cudaMemcpyHostToDevice));
	
	cutilSafeCall(cudaMalloc((void **)&colorsInWorldGPU, sizeof(float4) * anzPixels));
	cutilSafeCall(cudaMemcpy(colorsInWorldGPU, colorsInWorld, sizeof(float4) * anzPixels, cudaMemcpyHostToDevice));
	
	cutilSafeCall(cudaMalloc((void **)&colorTextureGPU, sizeof(float4) * anzPixels));
	cutilSafeCall(cudaMemcpy(colorTextureGPU, colorTexture, sizeof(float4) * anzPixels, cudaMemcpyHostToDevice));

	dim3 grid;
	dim3 block;

	int blockSize = CUDA_PushPull::maxThreadsPerBlock;

	int anzBlocks = 1;

	while (anzPixels > anzBlocks * blockSize)
	{
		anzBlocks++;
	}

	int numberOfIterations = ceil(((float(anzBlocks * blockSize)) / float(optimalNumberOfThreads)));

	int gridSize = min(anzBlocks, optimalNumberOfThreads / blockSize);

	grid = dim3(gridSize,1,1);
	block = dim3(blockSize, 1, 1);

	allocateTextureMemory(positionsInWorld, normalsInWorld, renderingWidth, renderingHeight);

	printf("numberOfIterations = %i\n", numberOfIterations);
	printf("gridDim = %i\n", grid.x);
	printf("blockDim = %i\n", block.x);

	printf("RadiosityShading(CUDA):\n");
	cudaError_t e;
	Timer timTimer;
	int offset = 0;
	for (int i = 0; i < numberOfIterations; i++)
	{	
//		numberOfValidElements = min(gridSize * blockSize, anzPixels - offset);

		setKernelParams(offset, CUDA_PushPull::maxThreadsPerBlock, renderingWidth, renderingHeight, TextureManager::anzLights, -1, Scene::sceneUnitsToMeters, lightSpaceMatrices_size, GameStateVBO::nearZ, GameStateVBO::farZ, ism_size, ism_atlas_size, TextureManager::sumOfWeightedIntensities);
		radiosityWithCUDA(grid, block, colorTextureGPU, positionsInWorld, normalsInWorld, clusterPointersGPU, vplPointersGPU, colorsInWorldGPU);
		
		offset += grid.x * block.x;//optimalNumberOfThreads; should be the same

		e = cudaGetLastError();
		if (e!=0)
		{
			printf("CUDA Error: %s\n", cudaGetErrorString(e));
			break;
		}
		cutilSafeCall(cudaThreadSynchronize());
		
		printf("%2.0f %% done\r", 100.0f*(float(i+1) / float(numberOfIterations)));
	}

	cutilSafeCall(cudaMemcpy(colorTexture, colorTextureGPU, sizeof(float4) * anzPixels, cudaMemcpyDeviceToHost));

	deallocateTextureMemory();

	const double dTimePerFrame = double(timTimer);
	timTimer.start();
	printf("\nDone (%f sek).\n", dTimePerFrame);
	renderingTime = dTimePerFrame;

//	cutilSafeCall(cudaFree(positionsInWorldGPU));
//	cutilSafeCall(cudaFree(normalsInWorldGPU));
	cutilSafeCall(cudaFree(colorsInWorldGPU));
	cutilSafeCall(cudaFree(colorTextureGPU));
	cutilSafeCall(cudaFree(vplPointersGPU.positionOfVPL));
	cutilSafeCall(cudaFree(vplPointersGPU.colorOfVPL));
	cutilSafeCall(cudaFree(vplPointersGPU.normalOfVPL_IntensityRatio));
	cutilSafeCall(cudaFree(vplPointersGPU.shadowMapAndLightSpaceOfVPL));
	cutilSafeCall(cudaFree(clusterPointersGPU.bounds_A));
	cutilSafeCall(cudaFree(clusterPointersGPU.bounds_B));
	cutilSafeCall(cudaFree(clusterPointersGPU.estRad_RadUpperBound_errorBound));
	cutilSafeCall(cudaFree(clusterPointersGPU.color_lch));
	cutilSafeCall(cudaFree(clusterPointersGPU.indices));
	cutilSafeCall(cudaFree(clusterPointersGPU.lightSpaceMatrices));
	cutilSafeCall(cudaFree(clusterPointersGPU.shadowMaps));

	delete[] ism_buffer;


	glBindTexture(GL_TEXTURE_2D, colorTextureGL);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA32F_ARB, renderingWidth, renderingHeight, 0, GL_RGBA, GL_FLOAT, colorTexture);
}

void CUDA_LightCuts::renderImageWithCUDA()
{
	int anzPixels = renderingHeight * renderingWidth;
	
	if (colorTexture!=0)
	{
		delete[] colorTexture;
		colorTexture = 0;
	}
	if (cutSizeTexture!=0)
	{
		delete[] cutSizeTexture;
		cutSizeTexture = 0;
	}

	float* ism_buffer = new float[ism_atlas_size * ism_atlas_size];
	for (int i = 0; i < ism_atlas_size * ism_atlas_size; i++)
	{
		ism_buffer[i] = shadowMap[i*4];
	}

	colorTexture = new float4[anzPixels];
	cutSizeTexture = new float4[anzPixels];

	int numberOfClusters = (TextureManager::anzLights*2) - 1;

	int numberOfBytes = 0;

	
//	float4* positionsInWorldGPU = 0;	numberOfBytes += sizeof(float4) * anzPixels; //takes now place in allocateTextureMemory!
//	float4* normalsInWorldGPU = 0;		numberOfBytes += sizeof(float4) * anzPixels; //takes now place in allocateTextureMemory!
										numberOfBytes += sizeof(float4) * anzPixels;
										numberOfBytes += sizeof(float4) * anzPixels;

	float4* colorsInWorldGPU = 0;		numberOfBytes += sizeof(float4) * anzPixels;
	float4* colorTextureGPU = 0;		numberOfBytes += sizeof(float4) * anzPixels;
	float4* cutSizeTextureGPU = 0;		numberOfBytes += sizeof(float4) * anzPixels;

	float4* lightCutsHeapGPU = 0;		//will be allocated later, don't count it yet

										numberOfBytes += 7 * sizeof(float4) * numberOfClusters;//see large comment directly below
										numberOfBytes += 2 * sizeof(int4) * numberOfClusters;  //see large comment directly below
										numberOfBytes += sizeof(float) * lightSpaceMatrices_size * lightSpaceMatrices_size * 4; //lightSpace matrices
										numberOfBytes += sizeof(float) * ism_atlas_size * ism_atlas_size; //shadow map

	printf("GPU: Allocating a total of %i KB", numberOfBytes >> 10);

	if (numberOfBytes > int(CUDA_PushPull::maxGlobalMemoryInBytes))
	{
		printf("\nERROR! Trying to allocate %i KB, but your device provides only %iKB. Cancelling rendering process.\n",   numberOfBytes >> 10,  CUDA_PushPull::maxGlobalMemoryInBytes >> 10);
		return;
	}

	VPL_InCUDA vplPointersGPU;
	ClusterInCUDA clusterPointersGPU;

	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.positionOfVPL, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.colorOfVPL, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.normalOfVPL_IntensityRatio, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&vplPointersGPU.shadowMapAndLightSpaceOfVPL, sizeof(int4) * numberOfClusters));

	cutilSafeCall(cudaMemcpy(vplPointersGPU.positionOfVPL, positionOfVPL, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(vplPointersGPU.colorOfVPL, colorOfVPL, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(vplPointersGPU.normalOfVPL_IntensityRatio, normalOfVPL_IntensityRatio, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(vplPointersGPU.shadowMapAndLightSpaceOfVPL, shadowMapAndLightSpaceOfVPL, sizeof(int4) * numberOfClusters, cudaMemcpyHostToDevice));

	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.bounds_A, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.bounds_B, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.estRad_RadUpperBound_errorBound, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.color_lch, sizeof(float4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.indices, sizeof(int4) * numberOfClusters));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.lightSpaceMatrices, sizeof(float) * lightSpaceMatrices_size * lightSpaceMatrices_size * 4));
	cutilSafeCall(cudaMalloc((void **)&clusterPointersGPU.shadowMaps, sizeof(float) * ism_atlas_size * ism_atlas_size));

	cutilSafeCall(cudaMemcpy(clusterPointersGPU.bounds_A, bounds_A, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.bounds_B, bounds_B, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.estRad_RadUpperBound_errorBound, estRad_RadUpperBound_errorBound, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.color_lch, color_lch, sizeof(float4) * numberOfClusters, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.indices, indices, sizeof(int4) * numberOfClusters, cudaMemcpyHostToDevice));	
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.lightSpaceMatrices, lightMatricesCUDA, sizeof(float) * lightSpaceMatrices_size * lightSpaceMatrices_size * 4, cudaMemcpyHostToDevice));
	cutilSafeCall(cudaMemcpy(clusterPointersGPU.shadowMaps, ism_buffer, sizeof(float) * ism_atlas_size * ism_atlas_size, cudaMemcpyHostToDevice));

//	cutilSafeCall(cudaMalloc((void **)&positionsInWorldGPU, sizeof(float4) * anzPixels));
//	cutilSafeCall(cudaMemcpy(positionsInWorldGPU, positionsInWorld, sizeof(float4) * anzPixels, cudaMemcpyHostToDevice));
		
	cutilSafeCall(cudaMalloc((void **)&colorsInWorldGPU, sizeof(float4) * anzPixels));
	cutilSafeCall(cudaMemcpy(colorsInWorldGPU, colorsInWorld, sizeof(float4) * anzPixels, cudaMemcpyHostToDevice));
	
//	cutilSafeCall(cudaMalloc((void **)&normalsInWorldGPU, sizeof(float4) * anzPixels));
//	cutilSafeCall(cudaMemcpy(normalsInWorldGPU, normalsInWorld, sizeof(float4) * anzPixels, cudaMemcpyHostToDevice));

	cutilSafeCall(cudaMalloc((void **)&colorTextureGPU, sizeof(float4) * anzPixels));
	cutilSafeCall(cudaMemcpy(colorTextureGPU, colorTexture, sizeof(float4) * anzPixels, cudaMemcpyHostToDevice));

	cutilSafeCall(cudaMalloc((void **)&cutSizeTextureGPU, sizeof(float4) * anzPixels));
	cutilSafeCall(cudaMemcpy(cutSizeTextureGPU, cutSizeTexture, sizeof(float4) * anzPixels, cudaMemcpyHostToDevice));


//	shadeAllPixels(CUDA_PushPull::maxThreadsPerBlock, anzPixels, TextureManager::anzLights, colorTextureGPU, cutSizeTextureGPU, positionsInWorldGPU, normalsInWorldGPU, clusterPointersGPU, vplPointersGPU, maximumCutSize, lightCutsGPU, sceneUnitsToMeters, lightSpaceMatrices_size, GameStateVBO::nearZ, GameStateVBO::farZ, ism_size, ism_atlas_size, TextureManager::sumOfWeightedIntensities);
	dim3 grid;
	dim3 block;

//	int numberOfClusters = (anzLights * 2) -1;
	int blockSize = CUDA_PushPull::maxThreadsPerBlock;

	int anzBlocks = 1;

	while (anzPixels > anzBlocks * blockSize)
	{
		anzBlocks++;
	}

	int numberOfIterations = ceil(((float(anzBlocks * blockSize)) / float(optimalNumberOfThreads)));
	numberOfIterations = ceil(float(numberOfIterations));
	int gridSize = min(anzBlocks, optimalNumberOfThreads / blockSize);



	grid = dim3(gridSize,1,1);
	block = dim3(blockSize, 1, 1);

//	int numberOfValidElements = gridSize * blockSize;

	int maximumCutSize = (CUDA_PushPull::maxGlobalMemoryInBytes - numberOfBytes) /  (sizeof(float4)* gridSize * blockSize); 
	printf(", %iKB remaining to store the lightcuts heap structure.\n", (CUDA_PushPull::maxGlobalMemoryInBytes - numberOfBytes) >> 10); 
	maximumCutSize = min(maximumCutSize, TextureManager::anzLights); //making a lightcut larger than the total number of lights available would just waste memory...
	maximumCutSize = min (maximumCutSize, maximumCutSizeAllowed);
	if ((maximumCutSize < maximumCutSizeAllowed) && (TextureManager::anzLights>maximumCutSize))
		printf("WARNING: Insufficient GPU memory available, maximum cut size reduced (%i) to accomodate!\n", maximumCutSize);
	printf("Allocating %iKB for the lightcuts and the heap structure.\n", (maximumCutSize * sizeof(float4) * gridSize * blockSize) >> 10);


	cutilSafeCall(cudaMalloc((void **)&lightCutsHeapGPU, sizeof(float4) * gridSize * blockSize * maximumCutSize));

	allocateTextureMemory(positionsInWorld, normalsInWorld, renderingWidth, renderingHeight);

	printf("numberOfIterations = %i\n", numberOfIterations);
	printf("gridDim = %i\n", grid.x);
	printf("blockDim = %i\n", block.x);

	printf("LightcutsShading(CUDA):\n");
	cudaError_t e;
	Timer timTimer;

	int offset = 0;

	float4* bla = new float4[gridSize * blockSize * maximumCutSize];

	for (int i = 0; i < numberOfIterations; i++)
	{	
//		numberOfValidElements = min(gridSize * blockSize, anzPixels - offset);

		cutilSafeCall(cudaMemcpy(lightCutsHeapGPU, bla, sizeof(float4) * gridSize * blockSize * maximumCutSize, cudaMemcpyHostToDevice));

		setKernelParams(offset, CUDA_PushPull::maxThreadsPerBlock, renderingWidth, renderingHeight, TextureManager::anzLights, maximumCutSize, Scene::sceneUnitsToMeters, lightSpaceMatrices_size, GameStateVBO::nearZ, GameStateVBO::farZ, ism_size, ism_atlas_size, TextureManager::sumOfWeightedIntensities);
		shadeAllPixels(grid, block, colorTextureGPU, cutSizeTextureGPU, positionsInWorld, normalsInWorld, clusterPointersGPU, vplPointersGPU, lightCutsHeapGPU, colorsInWorldGPU);
		
		offset += grid.x * block.x;//optimalNumberOfThreads; should be the same

		e = cudaGetLastError();
		if (e!=0)
		{
			printf("CUDA Error: %s\n", cudaGetErrorString(e));
			break;
		}
		cutilSafeCall(cudaThreadSynchronize());


		
		printf("%2.0f %% done\r", 100.0f*(float(i+1) / float(numberOfIterations)));
	}

	cutilSafeCall(cudaMemcpy(colorTexture, colorTextureGPU, sizeof(float4) * anzPixels, cudaMemcpyDeviceToHost));
	cutilSafeCall(cudaMemcpy(cutSizeTexture, cutSizeTextureGPU, sizeof(float4) * anzPixels, cudaMemcpyDeviceToHost));



	float sum = 0.0f;
	for(int i = 0; i<anzPixels; i++)
	{
		sum += cutSizeTexture[i].x;
	}
//	sum *= float(TextureManager::anzLights);
	sum /= float(anzPixels);
	cout << "Average cut size = " << sum << endl;
	avgCutSize = sum;


	deallocateTextureMemory();

	/*
	offset = 0; 
	pointerOffset = 0;
	for (int i = 0; i < numberOfIterations; i++)
	{	
		numberOfValidElements = min(gridSize * blockSize, anzPixels - offset);
		
		cutilSafeCall(cudaMemcpy(colorTexture + pointerOffset, colorTextureGPU + pointerOffset, sizeof(float4) * numberOfValidElements, cudaMemcpyDeviceToHost));
		cutilSafeCall(cudaMemcpy(cutSizeTexture + pointerOffset, cutSizeTextureGPU + pointerOffset, sizeof(float4) * numberOfValidElements, cudaMemcpyDeviceToHost));

		offset += optimalNumberOfThreads;
		pointerOffset += gridSize * blockSize;
	}
	*/
	const double dTimePerFrame = double(timTimer);
	timTimer.start();
	printf("\nDone (%f sek).\n", dTimePerFrame);
	renderingTime = dTimePerFrame;

//	cutilSafeCall(cudaFree(positionsInWorldGPU));
//	cutilSafeCall(cudaFree(normalsInWorldGPU));
	cutilSafeCall(cudaFree(colorsInWorldGPU));
	cutilSafeCall(cudaFree(colorTextureGPU));
	cutilSafeCall(cudaFree(cutSizeTextureGPU));
	cutilSafeCall(cudaFree(vplPointersGPU.positionOfVPL));
	cutilSafeCall(cudaFree(vplPointersGPU.colorOfVPL));
	cutilSafeCall(cudaFree(vplPointersGPU.normalOfVPL_IntensityRatio));
	cutilSafeCall(cudaFree(vplPointersGPU.shadowMapAndLightSpaceOfVPL));
	cutilSafeCall(cudaFree(clusterPointersGPU.bounds_A));
	cutilSafeCall(cudaFree(clusterPointersGPU.bounds_B));
	cutilSafeCall(cudaFree(clusterPointersGPU.estRad_RadUpperBound_errorBound));
	cutilSafeCall(cudaFree(clusterPointersGPU.color_lch));
	cutilSafeCall(cudaFree(clusterPointersGPU.indices));
	cutilSafeCall(cudaFree(clusterPointersGPU.lightSpaceMatrices));
	cutilSafeCall(cudaFree(clusterPointersGPU.shadowMaps));
	cutilSafeCall(cudaFree(lightCutsHeapGPU));

	delete[] ism_buffer;

	//TODO visualize lightcut...
	

/*
	for (int i = 0; i < anzPixels; i++)
	{
		if (colorTexture[i].x > 0.95f && colorTexture[i].y > 0.95f && colorTexture[i].z > 0.95f)
		{
			printf("color at pixel %i = %f, %f, %f. ", i, colorTexture[i].x, colorTexture[i].y, colorTexture[i].z);
			printf("cutSize = %i\n", int(cutSizeTexture[i].x));
		}
	}
	printf("tempVal = %f, %f, %f, %f\n", colorTexture[0].x, colorTexture[0].y, colorTexture[0].z, colorTexture[0].w);
*/

	glBindTexture(GL_TEXTURE_2D, colorTextureGL);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA32F_ARB, renderingWidth, renderingHeight, 0, GL_RGBA, GL_FLOAT, colorTexture);

	glBindTexture(GL_TEXTURE_2D, cutSizeTextureGL);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA32F_ARB, renderingWidth, renderingHeight, 0, GL_RGBA, GL_FLOAT, cutSizeTexture);
}

void CUDA_LightCuts::deleteCudaArrays()
{
	if (positionsInWorld!=0)
	{
		delete[] positionsInWorld;
		positionsInWorld = 0;
	}

	if (normalsInWorld!=0)
	{
		delete[] normalsInWorld;
		normalsInWorld = 0;
	}

	if (colorsInWorld!=0)
	{
		delete[] colorsInWorld;
		colorsInWorld = 0;
	}
	
	if (positionOfVPL!=0)
	{
		delete[] positionOfVPL;
		positionOfVPL = 0;
	}
	if (normalOfVPL_IntensityRatio!=0)
	{
		delete[] normalOfVPL_IntensityRatio;
		normalOfVPL_IntensityRatio = 0;
	}
	if (colorOfVPL!=0)
	{
		delete[] colorOfVPL;
		colorOfVPL = 0;
	}
	if (shadowMapAndLightSpaceOfVPL!=0)
	{
		delete[] shadowMapAndLightSpaceOfVPL;
		shadowMapAndLightSpaceOfVPL = 0;
	}
	if (indices!=0)
	{
		delete[] indices;
		indices = 0;
	}
	if (bounds_A!=0)
	{
		delete[] bounds_A;
		bounds_A = 0;
	}
	if (bounds_B!=0)
	{
		delete[] bounds_B;
		bounds_B = 0;
	}
	if (color_lch!=0)
	{
		delete[] color_lch;
		color_lch = 0;
	}
	if (estRad_RadUpperBound_errorBound!=0)
	{
		delete[] estRad_RadUpperBound_errorBound;
		estRad_RadUpperBound_errorBound = 0;
	}
}