#ifndef __CUDA_PUSH_PULL_H
#define __CUDA_PUSH_PULL_H

#include "CUDA_Structs.h"
#include "CUDA_Includes.h"
#include "../ResourceManager/TextureManager/Texture.h"

extern "C" void launch_pull_kernel(int ism_size, int numberOfLights, int textureW, int textureH, float* dataToReadFrom, float* dataToWriteTo, int numberOfAveragesOneThreadHasToCompute, int requiredNumberOfThreadsPerBlock, int level);
extern "C" void launch_push_kernel(int ism_size, int numberOfLights, int textureW, int textureH, float* dataToReadFrom, float* dataToWriteTo, int numberOfAveragesOneThreadHasToPushDown, int requiredNumberOfThreadsPerBlock, int level);


struct pushPullLevel;
struct pushPullLevel
{
	pushPullLevel* previous;
	pushPullLevel* next;
	float* data;
	int thisLevel;
};

class CUDA_PushPull
{
private:
public:
	static int maxThreadsPerBlock;
	static int maxGlobalMemoryInBytes;
	static float* pushPulledData;
	static float* notPushPulledData;
	static void initCuda(void);
	static void pullPushTexture();
};









#endif