#ifndef __CUDA_STRUCTS_H
#define __CUDA_STRUCTS_H

#include <vector_types.h>



//holds gpu pointers to the actual arrays
struct VPL_InCUDA 
{
	float4* positionOfVPL;
	float4* normalOfVPL_IntensityRatio; //intensity ratio wird in normalOfVPL_IntensityRatio.w gespeichert!!!
	float4* colorOfVPL;
	int4* shadowMapAndLightSpaceOfVPL;
};

struct ClusterInCUDA
{
	//Cluster structure, aligned memory to enable coalesced access:
	int4* indices; //indices.r = leftChild, indices.g = rightChild, indices.b = index of representative Light (in datastructure above!)
	float4* bounds_A;
	float4* bounds_B;
	float4* color_lch;
	float4* estRad_RadUpperBound_errorBound;
	float* lightSpaceMatrices;
	float* shadowMaps;
};

struct CudaTest
{
	int a;
	int b;
};



#endif