#ifndef _CAMERA
	#define _CAMERA
	
#include "../Math/Vector.h"
#include "../Math/Point.h"
#include <iostream>
#include <fstream>
#include <cstring>
#include <time.h>
#include <vector>
#include <GL/glew.h>
#include <FL/gl.H>

using namespace std;

class Camera
{
private:	
	float lastX, lastY;
	bool recording;
public:
	bool playback;
	Camera(void);
	float posX, posY, posZ, rotX, rotY;
	float lastPosX, lastPosY, lastPosZ, lastRotX, lastRotY;
	float currentFPS;
	float theoretFPS;
	Vector calcViewVector(void);
	Point getPosition(void);
	void view(void);//look through camera; positions the camera at posX,...; rotates it; ...

	void startRecording();
	void stopRecording();
	void saveSnapShot();
	bool getRecording(void);
	bool getPlayback(void);
	void playRecording(char* myRecordingFile);
	void stopPlayRecording(void);
};

#endif