#ifndef _GAME_STATE
	#define _GAME_STATE

#include <vector>
#include "../Camera/Camera.h"


using namespace std;


class GameState
{
private:
public:
	GameState(void);

	static Camera* camera;

	float lastX, lastY;

	/*Reserve memory, load textures/sounds/models,....
	*/
	virtual void initGameState(vector<vector<string> >& params)=0;

	/*Free memory, prepare for GameState-Change*/
	virtual void destroyGameState(void)=0;

	/*InputHandlers:*/
	virtual void processKey(unsigned char& key, int& x, int& y)=0;
	virtual void processKeyUp(unsigned char& key, int& x, int& y)=0;
	virtual void processSpecialKey(int& key, int& x, int& y)=0;
	virtual void processSpecialKeyUp(int& key, int& x, int& y)=0;
	virtual void processMousePassiveMovement(int& x, int& y)=0;
	virtual void processMouseMovement(int& x, int& y)=0;
	virtual void processMouseClick(int& button, int& state, int& x, int& y)=0;

	
	/*ResourceHandlers:*/
	virtual void loadTextures(void);
	virtual void loadModels(void);


	/*Rendering:*/
	virtual void render(void)=0;
	virtual void update(void)=0;
	virtual void reshape(int w, int h)=0;

};


#endif