#ifndef _GAME_STATE_PHYSICS
	#define _GAME_STATE_PHYSICS

#include "GameState.h"

#define NOMINMAX

// Physics code
#undef random
#include "extern/PhysX/Physics/include/NxPhysics.h"
#include "GameStates/GameStatePhysics/UserAllocator.h"
#include "GameStates/GameStatePhysics/Terrain.h"
#include "GameStates/GameStatePhysics/TerrainRender.h"
#include "GameStates/GameStatePhysics/Stream.h"
#include "GameStates/GameStatePhysics/ErrorStream.h"
#include "GameStates/GameStatePhysics/cooking.h"
#include <windows.h>



class GameStatePhysics: public GameState
{
private:
	int width,height;
	bool fullScreen;

	void setParamsAccordingToFileParams(vector<vector<string> >& params);
	bool initNX(void);
	void setDefaultParameterValues(void);
public:
	/*Reserve memory, load textures/sounds/models,....
	*/
	virtual void initGameState(vector<vector<string> >& params);

	/*Free memory, prepare for GameState-Change*/
	virtual void destroyGameState(void);

	/*InputHandlers:*/
	virtual void processKey(unsigned char& key, int& x, int& y);
	virtual void processKeyUp(unsigned char& key, int& x, int& y);
	virtual void processSpecialKey(int& key, int& x, int& y);
	virtual void processSpecialKeyUp(int& key, int& x, int& y);
	virtual void processMousePassiveMovement(int& x, int& y);
	virtual void processMouseMovement(int& x, int& y);
	virtual void processMouseClick(int& button, int& state, int& x, int& y);
	
	/*ResourceHandlers:*/


	/*Rendering:*/
	virtual void render(void);
	virtual void update(void);
	virtual void reshape(int w, int h);

};

#endif