#include <math.h>
#include "Point.h"



//std-constructor
Point::Point()
{
	x=0.0f; y=0.0f; z=0.0f;
}

//constructor. creates point from float coords
Point::Point(float _x, float _y, float _z)
{
	x=_x; y=_y; z=_z;
}

//Overloads assertion operator
//Enables the use of "==" for Vector-objects
bool Point::operator==(const Point& p)
{
	return ( (x==p.x)&& (y==p.y) && (z==p.z));
}


//Global operator overloading of "+" operator for 1 point and 1 vector.
//Returns the new point
Point operator+(Point p, Vector v)
{
	Point result;
	result.x = p.x+v.x;
	result.y = p.y+v.y;
	result.z = p.z+v.z;
	return result;
}

//Global operator overloading of "-" operator for 1 point and 1 vector.
//Returns the new point
Point operator-(Point p, Vector v)
{
	Point result;
	result.x = p.x-v.x;
	result.y = p.y-v.y;
	result.z = p.z-v.z;
	return result;
}

//Enables the use of "-" for Point-objects
Vector operator-(const Point& p1, const Point& p2)
{
	Vector result;
	result.x = p1.x - p2.x;
	result.y = p1.y - p2.y;
	result.z = p1.z - p2.z;
	return result;
}