#include <math.h>
#include "PullPush.h"

#include <stdio.h>
#include <string.h>
#include <fstream>
#include <assert.h>
#include <tchar.h>
#include <string>

#include <iostream>

#include <windows.h>
#include <stdlib.h> 


void pullPushTexture(float* p, int size, int maxLevel)
{
	if(pow(2.0, maxLevel) > size)
	{
		maxLevel = int(log(double(size))/log(2.0));
		cout << "Zu oft pushpullen geht nicht!! maxLevel wurde gesetzt auf: " << maxLevel << endl;
		return;
	}

	float** temp = new float*[maxLevel+1];
	float minCoeff = 1.0;

	temp[0] = new float[size*size];

	for(int k=0; k<(size*size); k++)
		temp[0][k] = p[k*4];

	//Pull-Phase:
	float numValid;
	float avg;
	int L;
	for(L=1; L<=maxLevel; L++)
	{
		minCoeff /= 2.0;
		int tempSize = int(size * minCoeff);
		temp[L] = new float[tempSize*tempSize];

		for (int i = 0; i < tempSize; i++) 
		{
			for (int j = 0; j < tempSize; j++)
			{
				numValid = 0;
				avg = 0.0f;

				float thresh = 0.05f*pow(2.0f, L-1);
				float a,b,c,d;

				a=temp[L-1][((i*4*tempSize)+j*2)];		
				b=temp[L-1][((i*4*tempSize)+j*2) + 1];
				c=temp[L-1][((i*4*tempSize)+j*2) + (tempSize*2)];
				d=temp[L-1][((i*4*tempSize)+j*2) + (tempSize*2)+1];

				
				
				float values[4] = {a,b,c,d};

				float newAverage = calcAverage(values, thresh);

				temp[L][((i*tempSize)+j)] = newAverage;
			}
		}
	}

	//Push - Phase:
	for (L = maxLevel; L> 0; L--)
	{
		int tempSize = int(size * minCoeff);

		for (int i = 0; i < tempSize; i++) 
		{
			for (int j = 0; j < tempSize; j++)
			{
				float avg = temp[L][i*tempSize+j];

				bool mask[4]; //true = ersetzen, false = stehen lassen
				float a,b,c,d;
				float thresh = 0.05f*pow(2.0f, L-1);
				int indices[4] = {((i*4*tempSize)+j*2), (((i*4*tempSize)+j*2) + 1), (((i*4*tempSize)+j*2) + (tempSize*2)), (((i*4*tempSize)+j*2) + (tempSize*2)+1)};
				a = temp[L-1][indices[0]];
				b = temp[L-1][indices[1]];
				c = temp[L-1][indices[2]];
				d = temp[L-1][indices[3]];
				float values[4] = {a,b,c,d};
				calcReplacement(mask, avg, values, thresh);

				for (int m = 0; m < 4; m++)
				{
					temp[L-1][indices[m]] = (!(mask[m]))*temp[L-1][indices[m]] + mask[m]*avg;
				}
			}
		}

		minCoeff *= 2.0;
	}

	for(int k=0; k<(size*size); k++)
	{
		p[k*4] = temp[0][k];
		p[k*4+1] = temp[0][k];
		p[k*4+2] = temp[0][k];
		p[k*4+3] = temp[0][k]; //z Werte 

	}

	for(L = 0; L<=maxLevel; L++)
	{	
		delete[] temp[L];
	}
	
	delete[] temp;
}

float calcAverage(float values[4], float thresh)
{
	int numValids = 0;
	vector<float> validValues;
	bool b = false;

	for (int i = 0; i < 4; i++)
	{
		if (b = (values[i] != 1.0f))
		{
			numValids+=b;
			validValues.push_back(values[i]);
		}		
	}
	
	if (numValids == 0)
		return 1.0f;

	if (numValids == 1)
		return validValues.at(0); //TODO das is nur so aus dem Gefuehl heraus, vlt sollte man
					// stattdessen das korrekte Value zurueckgeben
	if (numValids == 2)
	{return 1.0f;
		float diff = abs(validValues.at(1)-validValues.at(0));
		if (diff<=thresh)
			return ((validValues.at(1)+validValues.at(0))/2.0f);
		else
		{
			if (validValues.at(0)<validValues.at(1))
				return validValues.at(0);
			else
				return validValues.at(1);
		}
			return 1.0f; 
	}

	if (numValids == 3)
	{
		float diff1 = abs(validValues.at(1)-validValues.at(0));
		float diff2 = abs(validValues.at(2)-validValues.at(0));
		float diff3 = abs(validValues.at(2)-validValues.at(1));

		if ( diff1<=thresh && diff2<=thresh && diff3<=thresh )
		{
			return ( (validValues.at(0)+validValues.at(1)+validValues.at(2))/3.0f);
		}
		else
		{//den naeheren zurueckgeben!! TODO
			if (diff1<=thresh)
				return (  (validValues.at(0) + validValues.at(1))/2.0f );
			else if (diff2<=thresh)
				return (  (validValues.at(0) + validValues.at(2))/2.0f );
			else if (diff3<=thresh)
				return (  (validValues.at(1) + validValues.at(2))/2.0f );
			else
			{
				return 1.0f; //3 values, alle grob verschieden - ka was ich da sonst machen soll
			}
		}

		if (numValids == 4)
		{
			float diff1 = abs(validValues.at(1)-validValues.at(0));
			float diff2 = abs(validValues.at(2)-validValues.at(0));
			float diff3 = abs(validValues.at(3)-validValues.at(0));
			float diff4 = abs(validValues.at(2)-validValues.at(1));
			float diff5 = abs(validValues.at(3)-validValues.at(1));
			float diff6 = abs(validValues.at(3)-validValues.at(2));

			if ( diff1<=thresh && diff2<=thresh && diff3<=thresh && diff4<=thresh && diff5<=thresh && diff6<=thresh )
			{
				return ( (validValues.at(0)+validValues.at(1)+validValues.at(2)+validValues.at(3))/4.0f);
			}
			else
			{
				//versuche alle kombinationen mit 3 komponenten:
				if ( diff1<=thresh && diff2<=thresh && diff4<=thresh ) //a,b,c
					return ( (validValues.at(0)+validValues.at(1)+validValues.at(2)) / 3.0f);
				if ( diff1<=thresh && diff3<=thresh && diff5<=thresh ) //a,b,d
					return ( (validValues.at(0)+validValues.at(1)+validValues.at(3)) / 3.0f);
				if ( diff2<=thresh && diff3<=thresh && diff6<=thresh ) //a,c,d
					return ( (validValues.at(0)+validValues.at(2)+validValues.at(3)) / 3.0f);
				if ( diff4<=thresh && diff5<=thresh && diff6<=thresh ) //b,c,d
					return ( (validValues.at(1)+validValues.at(2)+validValues.at(3)) / 3.0f);
				
				//versuche alle kombinationen mit 2 komponenten:
				if ( diff1<=thresh )
					return ( (validValues.at(0)+validValues.at(1)) / 2.0f);
				if ( diff2<=thresh )
					return ( (validValues.at(0)+validValues.at(2)) / 2.0f);
				if ( diff3<=thresh )
					return ( (validValues.at(0)+validValues.at(3)) / 2.0f);
				if ( diff4<=thresh )
					return ( (validValues.at(1)+validValues.at(2)) / 2.0f);
				if ( diff5<=thresh )
					return ( (validValues.at(1)+validValues.at(3)) / 2.0f);
				if ( diff6<=thresh )
					return ( (validValues.at(2)+validValues.at(3)) / 2.0f);

			}
		}

	}

	return 1.0f;
}

void calcReplacement(bool mask[4], float average, float values[4], float thresh)
{
	int numValids = 0;
	for (int i = 0; i < 4; i++)
	{
		numValids += (values[i]!=1.0f);
	}

	for (int i = 0; i < 4; i++)
	{
		//Fallunterscheidung:
		//TODO ersetzen falls unterschiedlich genug
		if (average == 1.0f)
		{
			if ( numValids == 0 )
			{
				mask[i] = true;
			}
			else
			{
				if ( values[i] !=1.0f)
					mask[i] = false;
				else
					mask[i] = true;
				
			}
		}
		else
		{
			if ( values[i] ==1.0f)
				mask[i] = true;
			else
			{
				float diff = abs ( average - values[i] );
				if (diff > thresh)
					mask[i] = true;
				else
					mask[i] = false;
			}
		}
	}

}