#ifndef _RaytracingMath
#define _RaytracingMath

#include <math.h>
#include "Point.h"
#include "Vector.h"
#include "Ray.h"
#include "Triangle.h"

#include <iostream>
using namespace std;



#define PI 3.141592654
#define SMALL_NUM  0.00000001 // anything that avoids division overflow
// dot product (3D) which allows vector operations in arguments
#define dot(u,v)   ((u).x * (v).x + (u).y * (v).y + (u).z * (v).z)

// intersect_RayTriangle(): intersect a ray with a 3D triangle
//    Input:  a ray R, and a triangle T
//    Output: *I = intersection point (when it exists)
//    Return: -1 = triangle is degenerate (a segment or point)
//             0 = disjoint (no intersect)
//             1 = intersect in unique point I1
//             2 = are in the same plane
int intersect_RayTriangle( Ray R, Triangle T, Point* I );

#endif