//#ifndef __TGA_HEADER__
//#define __TGA_HEADER__

//#include "MainHeader.h"
//#include "TGATextureHeader.h"

#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <stdio.h>
//#include <GL/glew.h>

#include <GL/glew.h>
#include <FL/gl.H>
#include <GL/glut.h>
//#include "gl.h"

#include <math.h>

typedef	struct									
{
	GLubyte	* imageData;									// Image Data (Up To 32 Bits)
	GLuint	bpp;											// Image Color Depth In Bits Per Pixel
	GLuint	width;											// Image Width
	GLuint	height;											// Image Height
	GLuint	texID;											// TGATexture ID Used To Select A TGATexture
	GLuint	type;											// Image Type (GL_RGB, GL_RGBA)
} TGATexture;	

typedef struct
{
	GLubyte Header[12];									// TGA File Header
} TGAHeader;


typedef struct
{
	GLubyte		header[6];								// First 6 Useful Bytes From The Header
	GLuint		bytesPerPixel;							// Holds Number Of Bytes Per Pixel Used In The TGA File
	GLuint		imageSize;								// Used To Store The Image Size When Setting Aside Ram
	GLuint		temp;									// Temporary Variable
	GLuint		type;	
	GLuint		Height;									//Height of Image
	GLuint		Width;									//Width ofImage
	GLuint		Bpp;									// Bits Per Pixel
} TGA;

bool LoadTGA(TGATexture * TGATexture, char * filename);
bool LoadCompressedTGA(TGATexture * TGATexture, char * filename, FILE * fTGA);
bool LoadUncompressedTGA(TGATexture * TGATexture, char * filename, FILE * fTGA);
//#endif