#include "Scene.h"


vector<string> Scene::modelsToLoad;
int Scene::numOfModelsToLoad;

float Scene::biasByPercentageOfLightVector;
float Scene::sceneUnitsToMeters;

float Scene::sceneBboxDiagonal;

list<AreaLight*> Scene::areaLightSources;

void Scene::readSceneFromFile(string fileName)
{
	ifstream inFile;    
	inFile.open(fileName.c_str());
    if (!inFile) 
	{
		printf("Unable to open file %s.\n", fileName.c_str());
		inFile.close();
    }
		
	string ab;

	getline(inFile, ab);

	if(ab.compare("!MODELS!")==0)
	{
		while(getline(inFile, ab))
		{
			if(ab.compare("!ENDMODELS!")==0)
			{

				break;
			}
			else
			{
				modelsToLoad.push_back(ab);
			}
		}
	}
	ab = "";
	while (ab.compare("")==0)
	{
		getline(inFile, ab);
	}
	if(ab.compare("!LIGHTS!")==0)
	{
		while(getline(inFile, ab))
		{
			if(ab.compare("!ENDLIGHTS!")==0)
			{
				break;
			}
			else if(ab.compare("!LIGHT!")==0)
			{
				string name;
				float minX, minY, minZ, maxX, maxY, maxZ, intensity, primDirX, primDirY, primDirZ;	
				int primLights, ratio;

				getline(inFile, ab); name = ab;
				getline(inFile, ab); minX = float(atof(ab.c_str()));
				getline(inFile, ab); minY = float(atof(ab.c_str()));
				getline(inFile, ab); minZ = float(atof(ab.c_str()));
				getline(inFile, ab); maxX = float(atof(ab.c_str()));
				getline(inFile, ab); maxY = float(atof(ab.c_str()));
				getline(inFile, ab); maxZ = float(atof(ab.c_str()));
				getline(inFile, ab); primDirX = float(atof(ab.c_str()));
				getline(inFile, ab); primDirY = float(atof(ab.c_str()));
				getline(inFile, ab); primDirZ = float(atof(ab.c_str()));
				
				getline(inFile, ab); primLights = atoi(ab.c_str());
				getline(inFile, ab); ratio = atoi(ab.c_str());
				getline(inFile, ab); intensity = float(atof(ab.c_str()));
			
				areaLightSources.push_back(new AreaLight(name, Point(minX, minY, minZ), Point(maxX, maxY ,maxZ), Point(primDirX, primDirY, primDirZ), primLights, ratio, intensity));
			}
		}
	}
	ab = "";
	while (ab.compare("")==0)
	{
		getline(inFile, ab);
	}

	if(ab.compare("!SCENEUNITSTOMETERS!")==0)
	{
		getline(inFile, ab); Scene::sceneUnitsToMeters = float(atof(ab.c_str()));
	}
	getline(inFile, ab); //READ END SCENE UNITS TO METERS STRING

	ab = "";
	while (ab.compare("")==0)
	{
		getline(inFile, ab);
	}

	if(ab.compare("!BIASBYPERCENTAGEOFLIGHTVECTOR!")==0)
	{
		getline(inFile, ab); Scene::biasByPercentageOfLightVector = float(atof(ab.c_str()));
	}
	getline(inFile, ab); //READ END BIAS STRING

	//TODO den rest einlesen
	/*while(getline(inFile, ab))
	{
		if (ab.find_first_of("*")!=string::npos)
		{
			continue;
		}
		if(ab.compare("")==0) //skip empty lines
		{
			continue;
		}

		size_t pos = ab.find("=");
		if (ab.find("=") == string::npos) 
		{
			printf("Error reading file %s. Please check for spelling-errors.\n",fileName.c_str());
			continue;
		}
		a.clear();

		string name = ab.substr(0,pos-1);
		string value = ab.substr(pos+1);
		a.push_back(name);
		a.push_back(value);
		params.push_back(a);
	}*/
	
	inFile.close();

//	
}

void Scene::destroyScene(void)
{
	list<AreaLight*>::iterator it5;
	for (it5 = areaLightSources.begin(); it5 != areaLightSources.end(); it5++)
	{
		delete (*it5);
		(*it5) = 0;
	}
	areaLightSources.clear();

	modelsToLoad.clear();
}
