#ifndef __SHADER_MANAGER
#define __SHADER_MANAGER


#include <vector>
#include <GL/glew.h>
#include <FL/gl.H>

#include <stdio.h>
#include <string.h>
#include <fstream>
#include <assert.h>
#include <tchar.h>
#include <string>

#include <iostream>

using namespace std;


class Shader 
{
	public:
		Shader(char* shaderName, char* vertShaderFile, char* pixShaderFile);
		~Shader(void);	
		
		//name of shader
		char* shaderName;
		GLuint glShaderName;
};

class ShaderManager
{
	public:
		static bool CheckShader(int Object, int Type, const char* Message, char* name);
		static bool CheckProgram(int Object, int Type, const char* Message);
		static string LoadShader(const char* filename);

		static vector<Shader*> allShaders; 
		
		static char* shaderPaths[];

		static void loadAllShaders(char* filenames[], int numOfShaders);
		static void loadShader(char* shaderName, char* vertShaderFile, char* pixShaderFile);

		
		// Get a shader (index of it)
		static GLuint fetchShader(char* shaderName);

		static void deleteAllShaders(void);
};


#endif
