// generated by Fast Light User Interface Designer (fluid) version 1.0110

#include "fluidFile.h"
#include "GameStates/global.h"
#include "GraphicsDemo.h"
#include "Math/AreaLight.h"
#include "GameStates/GameStateVBO_RenderingStuff.h"

void cleanUpAndExit(Fl_Widget* widget, void*) {
  if (widget!=NULL)
{
delete widget;
widget = NULL;
exit(0);
}
}

Fl_Double_Window *myMainWindow=(Fl_Double_Window *)0;

Fl_Button *render_software_button=(Fl_Button *)0;

static void cb_render_software_button(Fl_Button*, void*) {
  renderingWidth = atoi(width_input->value());
	renderingHeight = atoi(height_input->value());

renderMode = 2;
  renderImageToDisk(renderingWidth, renderingHeight);
}

Fl_Input *width_input=(Fl_Input *)0;

Fl_Input *height_input=(Fl_Input *)0;

static void cb_Visualize(Fl_Check_Button*, void*) {
  showLights = !showLights;
}

Fl_Choice *light_choice_input=(Fl_Choice *)0;

static void cb_light_choice_input(Fl_Choice* o, void*) {
  list<AreaLight*>::iterator it;

  AreaLight* someLight = 0;
  for (it = Scene::areaLightSources.begin(); it != Scene::areaLightSources.end(); it++)
{
	if (strcmp(o->text(), (*it)->name.c_str())==0)
	{
		someLight = *it;
		break;
	}
  }
  
	primary_lights_input ->static_value(someLight->anzPrimaryLights_c);

	vpls_per_pl_input ->static_value(someLight->virtualToPrimaryRatio_c);

	intensity_input->static_value(someLight->intensity_c);
}

Fl_Input *primary_lights_input=(Fl_Input *)0;

static void cb_primary_lights_input(Fl_Input*, void*) {
  int bla = 0;
}

Fl_Input *vpls_per_pl_input=(Fl_Input *)0;

Fl_Input *intensity_input=(Fl_Input *)0;

static void cb_intensity_input(Fl_Input*, void*) {
  AreaLight* someLight = 0;

  list<AreaLight*>::iterator it;
  for (it = Scene::areaLightSources.begin(); it != Scene::areaLightSources.end(); it++)
  {
	if (strcmp(lightChoice->text(), (*it)->name.c_str())==0)
	{
		someLight = *it;
		someLight->intensity = atof(intensity_input->value());	
		break;
	}
  };
}

Fl_Button *regenerate_button=(Fl_Button *)0;

static void cb_regenerate_button(Fl_Button*, void*) {
  reRenderISMs = true;
reBuildLightTree = true;

  AreaLight* someLight = 0;

  list<AreaLight*>::iterator it;
  for (it = Scene::areaLightSources.begin(); it != Scene::areaLightSources.end(); it++)
  {
	if (strcmp(lightChoice->text(), (*it)->name.c_str())==0)
	{
		someLight = *it;
        someLight->virtualToPrimaryRatio = atoi(vpls_per_pl_input->value());
		someLight->intensity = atof(intensity_input->value());	
		someLight->anzPrimaryLights = atoi(primary_lights_input->value());
		TextureManager::generateLightTextures();
		break;
	}
  };
}

Fl_Button *render_hardware_button=(Fl_Button *)0;

static void cb_render_hardware_button(Fl_Button*, void*) {
  renderingWidth = atoi(width_input->value());
	renderingHeight = atoi(height_input->value());

renderMode = 3;
  renderImageToDisk(renderingWidth, renderingHeight);
}

static void cb_Open(Fl_Menu_*, void*) {
  // Create the file chooser, and show it
    Fl_File_Chooser chooser("./resources/Scenes",                        // directory
                            "*",                        // filter
                            Fl_File_Chooser::SINGLE, 	// chooser type
                            "Select Scene To Load");        	// title
    chooser.show();

    // Block until user picks something.
    //     (The other way to do this is to use a callback())
    //
    while(chooser.shown())
        { Fl::wait(); }

    // User hit cancel?
    if ( chooser.value() == NULL )
        { 
		return;
        	//fprintf(stderr, "(User hit 'Cancel')\n"); return; 
        }
/*
    // Print what the user picked
    fprintf(stderr, "--------------------\n");
    fprintf(stderr, "DIRECTORY: '%s'\n", chooser.directory());
    fprintf(stderr, "    VALUE: '%s'\n", chooser.value());
    fprintf(stderr, "    COUNT: %d files selected\n", chooser.count());
*/
	sceneIsBeingLoaded = true;
	//fltkWait();
	GameStateVBO::destroyGameState_static();
	Scene::destroyScene();
	string sceneFile = string(chooser.value());
	Scene::readSceneFromFile(sceneFile);
	ModelManager::loadAllModels(Scene::modelsToLoad);
	TextureManager::generateLightTextures();
   	list<AreaLight*>::iterator it;

	for (it = Scene::areaLightSources.begin(); it != Scene::areaLightSources.end(); it++)
	{
		lightChoice->add((*it)->name.c_str());
	}

	AreaLight* firstLight =  (*Scene::areaLightSources.begin());
	lightChoice->value(0);

	primary_lights_input ->static_value(firstLight->anzPrimaryLights_c);

	vpls_per_pl_input ->static_value(firstLight->virtualToPrimaryRatio_c);

	intensity_input->static_value(firstLight->intensity_c);
	reRenderISMs = true;
	reBuildLightTree = true;
	GameStateVBO::lastRenderingWidth = -1;
	GameStateVBO::lastRenderingHeight = -1;
	sceneIsBeingLoaded = false;
   /*
    // Multiple files? Show all of them
    if ( chooser.count() > 1 ) {
        for ( int t=1; t<=chooser.count(); t++ ) {
            fprintf(stderr, " VALUE[%d]: '%s'\n", t, chooser.value(t));
        }
    }
    */;
}

Fl_Menu_Item menu_[] = {
 {"File", 0,  0, 0, 64, FL_NORMAL_LABEL, 0, 14, 0},
 {"Open Scene", 0,  (Fl_Callback*)cb_Open, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};

Fl_Button *render_software_radiosity_button=(Fl_Button *)0;

static void cb_render_software_radiosity_button(Fl_Button*, void*) {
  renderingWidth = atoi(width_input->value());
	renderingHeight = atoi(height_input->value());

renderMode = 0;
  renderImageToDisk(renderingWidth, renderingHeight);
}

Fl_Button *render_hardware_radiosity_button=(Fl_Button *)0;

static void cb_render_hardware_radiosity_button(Fl_Button*, void*) {
  renderingWidth = atoi(width_input->value());
	renderingHeight = atoi(height_input->value());

renderMode = 1;
  renderImageToDisk(renderingWidth, renderingHeight);
}

static void cb_Visualize1(Fl_Check_Button*, void*) {
  showClustering = !showClustering;
}

static void cb_Advanced(Fl_Button*, void*) {
  make_window();
advanced_properties_window->show();


sprintf_s(numThread_c, "%i", optimalNumberOfThreads);
sprintf_s(ism_size_c, "%i", ism_size);
ism_size_input->static_value(ism_size_c);
num_of_threads_input->static_value(numThread_c);
}

int main(int argc, char **argv) {
  Fl::scheme("plastic");
  { myMainWindow = new Fl_Double_Window(637, 575);
    { MyGlWindow* o = new MyGlWindow(190, -1, 450, 576);
      o->box(FL_EMBOSSED_BOX);
      o->color((Fl_Color)FL_BACKGROUND_COLOR);
      o->selection_color((Fl_Color)FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor((Fl_Color)FL_FOREGROUND_COLOR);
      o->align(FL_ALIGN_CENTER);
      o->when(FL_WHEN_RELEASE);
      Fl_Group::current()->resizable(o);
    } // MyGlWindow* o
    { Fl_Box* o = new Fl_Box(15, 297, 160, 273, "Rendering");
      o->box(FL_PLASTIC_DOWN_BOX);
      o->selection_color((Fl_Color)FL_GRAY0);
      o->labelfont(1);
      o->labelcolor((Fl_Color)FL_GRAY0);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(20, 483, 150, 76, "Lightcuts");
      o->box(FL_PLASTIC_UP_BOX);
      o->selection_color((Fl_Color)FL_GRAY0);
      o->labelfont(1);
      o->labelcolor((Fl_Color)FL_GRAY0);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(20, 393, 150, 76, "Radiosity");
      o->box(FL_PLASTIC_UP_BOX);
      o->selection_color((Fl_Color)FL_GRAY0);
      o->labelfont(1);
      o->labelcolor((Fl_Color)FL_GRAY0);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    } // Fl_Box* o
    { render_software_button = new Fl_Button(25, 506, 140, 20, "Render (Software)");
      render_software_button->labelsize(16);
      render_software_button->callback((Fl_Callback*)cb_render_software_button);
    } // Fl_Button* render_software_button
    { width_input = new Fl_Input(65, 330, 105, 24, "Width:");
      width_input->type(2);
    } // Fl_Input* width_input
    { height_input = new Fl_Input(65, 355, 105, 24, "Height:");
      height_input->type(2);
    } // Fl_Input* height_input
    { Fl_Box* o = new Fl_Box(15, 204, 160, 83, "Options");
      o->box(FL_PLASTIC_DOWN_BOX);
      o->labelfont(1);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    } // Fl_Box* o
    { Fl_Check_Button* o = new Fl_Check_Button(20, 240, 125, 15, "Visualize Lights");
      o->down_box(FL_DOWN_BOX);
      o->shortcut(0x76);
      o->callback((Fl_Callback*)cb_Visualize);
      o->value(1);
    } // Fl_Check_Button* o
    { Fl_Box* o = new Fl_Box(15, 25, 160, 164, "Lights");
      o->box(FL_PLASTIC_DOWN_BOX);
      o->labelfont(1);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    } // Fl_Box* o
    { light_choice_input = new Fl_Choice(60, 50, 110, 24, "Light:");
      light_choice_input->down_box(FL_BORDER_BOX);
      light_choice_input->callback((Fl_Callback*)cb_light_choice_input);
    } // Fl_Choice* light_choice_input
    { primary_lights_input = new Fl_Input(130, 81, 40, 24, "# primary Lights:");
      primary_lights_input->type(2);
      primary_lights_input->callback((Fl_Callback*)cb_primary_lights_input);
    } // Fl_Input* primary_lights_input
    { vpls_per_pl_input = new Fl_Input(130, 106, 40, 24, "# VPLs per PL");
      vpls_per_pl_input->type(2);
    } // Fl_Input* vpls_per_pl_input
    { intensity_input = new Fl_Input(130, 131, 40, 24, "intensity");
      intensity_input->type(1);
      intensity_input->callback((Fl_Callback*)cb_intensity_input);
    } // Fl_Input* intensity_input
    { regenerate_button = new Fl_Button(20, 165, 145, 20, "Regenerate");
      regenerate_button->callback((Fl_Callback*)cb_regenerate_button);
    } // Fl_Button* regenerate_button
    { render_hardware_button = new Fl_Button(25, 531, 140, 20, "Render (CUDA)");
      render_hardware_button->labelsize(16);
      render_hardware_button->callback((Fl_Callback*)cb_render_hardware_button);
    } // Fl_Button* render_hardware_button
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(5, 0, 175, 20);
      o->menu(menu_);
    } // Fl_Menu_Bar* o
    { render_software_radiosity_button = new Fl_Button(25, 414, 140, 20, "Render (Software)");
      render_software_radiosity_button->labelsize(16);
      render_software_radiosity_button->callback((Fl_Callback*)cb_render_software_radiosity_button);
    } // Fl_Button* render_software_radiosity_button
    { render_hardware_radiosity_button = new Fl_Button(25, 439, 140, 20, "Render (CUDA)");
      render_hardware_radiosity_button->labelsize(16);
      render_hardware_radiosity_button->callback((Fl_Callback*)cb_render_hardware_radiosity_button);
    } // Fl_Button* render_hardware_radiosity_button
    { Fl_Check_Button* o = new Fl_Check_Button(20, 260, 145, 15, "Visualize Clustering");
      o->down_box(FL_DOWN_BOX);
      o->shortcut(0x76);
      o->callback((Fl_Callback*)cb_Visualize1);
      o->value(0);
    } // Fl_Check_Button* o
    { Fl_Button* o = new Fl_Button(105, 210, 64, 20, "Advanced...");
      o->labelsize(10);
      o->callback((Fl_Callback*)cb_Advanced);
    } // Fl_Button* o
    myMainWindow->end();
  } // Fl_Double_Window* myMainWindow
  myMainWindow->callback(cleanUpAndExit);
  lightChoice = light_choice_input;
  myMainWindow->show(argc, argv);
  return Fl::run();
}
static int x; 

Fl_Double_Window *advanced_properties_window=(Fl_Double_Window *)0;

static void cb_PullPush(Fl_Check_Button*, void*) {
  pullPush = !pullPush;
reRenderISMs = true;
}

static void cb_Max(Fl_Input_Choice* o, void*) {
  pullPushMaxLevel = atoi(o->value());
}

Fl_Input *ism_size_input=(Fl_Input *)0;

static void cb_ism_size_input(Fl_Input*, void*) {
  ism_size = atoi(ism_size_input->value());
ism_atlas_size = ceil(sqrt(float(TextureManager::anzLights))) * ism_size;
reRenderISMs = true;
}

Fl_Input *num_of_threads_input=(Fl_Input *)0;

static void cb_num_of_threads_input(Fl_Input*, void*) {
  optimalNumberOfThreads = atoi(num_of_threads_input->value());
}

Fl_Double_Window* make_window() {
  { advanced_properties_window = new Fl_Double_Window(235, 179);
    { Fl_Box* o = new Fl_Box(5, 6, 225, 172, "Options");
      o->box(FL_PLASTIC_DOWN_BOX);
      o->labelfont(1);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
    } // Fl_Box* o
    { Fl_Check_Button* o = new Fl_Check_Button(20, 110, 85, 15, "PullPush");
      o->down_box(FL_DOWN_BOX);
      o->callback((Fl_Callback*)cb_PullPush);
      o->value(1);
    } // Fl_Check_Button* o
    { Fl_Input_Choice* o = new Fl_Input_Choice(95, 131, 120, 24, "Max Level:");
      o->callback((Fl_Callback*)cb_Max);
      o->value("2");
    } // Fl_Input_Choice* o
    { Fl_Input* o = ism_size_input = new Fl_Input(140, 66, 75, 24, "ISM size");
      ism_size_input->type(2);
      ism_size_input->callback((Fl_Callback*)cb_ism_size_input);
      ism_size_input->when(FL_WHEN_CHANGED);
      o->value("128");
    } // Fl_Input* ism_size_input
    { Fl_Input* o = num_of_threads_input = new Fl_Input(140, 36, 75, 24, "# threads / Iteration");
      num_of_threads_input->type(2);
      num_of_threads_input->callback((Fl_Callback*)cb_num_of_threads_input);
      num_of_threads_input->when(FL_WHEN_CHANGED);
      o->value("32768");
    } // Fl_Input* num_of_threads_input
    advanced_properties_window->end();
  } // Fl_Double_Window* advanced_properties_window
  return advanced_properties_window;
}
